// Gilles Tran 
// 26/1/2002
// Pov-ray Mug render

// some modifications by Chris Cason, so don't blame Gilles for anything that's wrong ... ;)


#include "colors.inc"
#include "functions.inc"
#include "textures.inc"
#include "woods.inc"

#declare UsePhotons = 1 ;

#if (UsePhotons)
global_settings {
    photons{    count 400000    autostop 0    jitter .4  }
}
#end

camera {
//location  <0.0, 65.0, -70.0>
  location  <35, 35, -50.0>
  direction 2.2*z
  right     x*image_width/image_height
//look_at   <0.0, 10.0,  0.0>
  look_at   <-5.0, 11.0,  0.0>
}
light_source{-z*200 color rgb 6 fade_power 2 fade_distance 100 rotate x*40 rotate y*-40
    area_light x*5,z*5 5,5 adaptive 0 circular orient
}
light_source{-z*200 color rgb <1,0.8,0.8> fade_power 2 fade_distance 100 rotate x*70 rotate y*60 shadowless}
light_source{-z*200 color rgb <1,0.8,0.8> fade_power 2 fade_distance 100 rotate x*10 rotate y*180 shadowless}
#declare V_WorldBoundMin = <-9.232930, 0.000000, -9.232977>;
#declare V_WorldBoundMax = <9.232977, 24.165247, 9.231353>;
#declare T_material1 = texture {
  	pigment { image_map{jpeg "povbump"} }
//	pigment { rgb <0.91,0.95,0.96>*0.7 } 
	normal { bump_map {jpeg "povbump" interpolate 2 bump_size 1 } }
    finish {
        ambient 0
        brilliance 4
        diffuse 0.55
        metallic
        specular 0.80
        roughness 1/80
        reflection {0.1,0.99 metallic fresnel on}
    }
} 

#declare Mug=   
union{   
    #include "mainmug_o.inc"
    object{ P_Default_object_1 }
    #include "anse_o.inc"
    object{ P_Default_object_1 }
    
}
union{
    object{Mug 
        interior{ior 10}
        rotate y*140 
        translate <-5,0,0>
    }
    
#if (false)
    union{
        object{Mug}
        #declare T_material1 = texture {
        	pigment {image_map{jpeg "coffeemap"}} 
        	finish{ambient 0 diffuse 1 reflection 0.5}
        }
        #include "coffee_o.inc"
        object{ P_Default_object_1 }
        interior{ior 10}
    
        rotate y*190 
        translate <20,0,15>
    }
#end
    photons{
        target
        reflection on
    }
}

sky_sphere
{
   pigment{
        image_map{
        jpeg "appartmap" 
        map_type 2
        }
    }
    rotate -y*60
    scale 100*<1,2,1>
    translate -y*150
}

#if (false)
cylinder{-y*10,y*10,1
    texture{
        pigment{
            image_map{
            jpeg "appartmap" 
            map_type 2
            }
        }
    finish{ambient 1 diffuse 0}
    }
    rotate -y*60
    scale 100*<1,2,1>
    translate -y*150
    no_shadow
}
#end

#declare txtWood0=
    texture{T_Wood33 
    finish{ambient 0 diffuse 0.5 reflection 0.4} 
}

#declare i=0;                     
#declare rd=seed(0);
#declare txtWood= texture{
    average
    texture_map{
        #while (i<10)
            [1 txtWood0 normal{bumps 0.1 scale <1,1,20>/200 translate <rand(rd),rand(rd),rand(rd)>*0.05}]
            #declare i=i+1;
        #end    
    }
}


cylinder{-y,0,100 
    texture{
//        pigment{Red}        finish{ambient 0 diffuse 1}
        txtWood
        scale 40 rotate x*8 rotate y*-60
    }
}

